BUS_CONFIG_INTR(9)

NAME
BUS_CONFIG_INTR - configure interrupt polarity and trigger mode

SYNOPSIS
#include <sys/param.h>
#include <sys/bus.h>
int
BUS_CONFIG_INTR(device_t dev, int irq, enum intr_trigger trig, enum intr_polarity pol);

DESCRIPTION
The BUS_CONFIG_INTR() method allows bus or device drivers to provide interrupt polarity and trigger mode to parent busses. This typically bubbles all the way up to the root bus (e.g. nexus) where the necessary actions are taken to actually program the hardware. Since the BUS_CONFIG_INTR() method takes an interrupt number, it is assumed but not necessarily required that it is called prior to BUS_SETUP_INTR(9).

The trig argument can be one of:

INTR_TRIGGER_CONFORM
    The interrupt trigger mode is standard for the bus to which the device is attached.

INTR_TRIGGER_EDGE
    The interrupt is edge triggered. This means that the interrupt is raised by the rising edge of the signal on the interrupt line. The signal typically reverts to the original state so as to cause a spike.

INTR_TRIGGER_LEVEL
    The interrupt is level triggered. This means that the interrupt is raised when the signal on the interrupt line transitions and remains unchanged after that until the interrupt has been serviced, after which the signal transitions back.

The pol argument can be any one of:

INTR_POLARITY_CONFORM
    The interrupt polarity is standard for the bus to which the device is attached.

INTR_POLARITY_HIGH
    The interrupt is activated by a high voltage on the interrupt line.

INTR_POLARITY_LOW
    The interrupt is activated by a low voltage on the interrupt line.

RETURN VALUES
Zero is returned on success, otherwise an appropriate error is returned.

SEE ALSO
BUS_SETUP_INTR(9), BUS_TEARDOWN_INTR(9), device(9), driver(9)

HISTORY
The BUS_CONFIG_INTR() method first appeared in FreeBSD 5.2.

AUTHORS
This manual page was written by Marcel Moolenaar <marcel@xcllnt.net>.